<!DOCTYPE html>
<html lang="en"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:th="http://www.thymeleaf.org"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layout}">
<head>
    <meta charset="UTF-8">
    <title>Journal</title>
</head>
<body>
<main layout:fragment="main" class="container-xxl bd-gutter mt-3 my-md-4 bd-layout">
    <div th:include="sidebar/sidebar_journal::sidebar_journal" th:remove="tag">
        sidebar
    </div>
    <main class="bd-main-xxl">
        <div class="row">
            <div class="col-md-12">
                <div class="card shadow-sm">
                    <div class="card-header">
                        <h5>Create Journal</h5>
                    </div>
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-4 mb-2">
                                <div class="card shadow-sm">
                                    <div class="card-header bg-white">
                                        <h6>Select Template Journal</h6>
                                    </div>
                                    <div class="card-body">
                                        <form action="" method="get">
                                            <div class="form-group mb-2">
                                                <label>Category</label>
                                                <select id="select-category" th:if="${category == null}" class="form-select js-example-basic-single" name="category">
                                                    <option value=""></option>
                                                </select>
                                                <input type="text" class="form-control" disabled readonly th:value="${category.category}"
                                                       th:if="${category != null}">
                                            </div>
                                            <div class="form-group mb-2">
                                                <label>Template</label>
                                                <select id="select-subcategory" th:if="${category == null}" class="form-select js-example-basic-single" name="template">
                                                    <option value=""></option>
                                                </select>
                                                <input type="text" class="form-control" disabled readonly th:value="${template.code + ' - ' + template.name}"
                                                    th:if="${template != null}">
                                            </div>
                                            <div class="form-group mb-2">
                                                <button type="submit" class="btn btn-info" th:if="${category == null}">Search</button>
                                                <a th:href="@{/journal}" th:if="${category != null}" class="btn btn-danger">Clear</a>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>
                            <div class="col-md-8 mb-2" th:if="${template != null}">
                                <div class="card shadow-sm">
                                    <div class="card-header">
                                        <h6>"Search Result"</h6>
                                    </div>
                                    <div class="card-body">
                                        <div class="alert alert-danger alert-dismissible fade show" role="alert" th:if="${failed != null}">
                                            <strong th:text="${failed}"></strong>
                                            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                                        </div>
                                        <div class="alert alert-success alert-dismissible fade show" role="alert" th:if="${success != null}">
                                            <strong th:text="${success}"></strong>
                                            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                                        </div>
                                        <div class="alert alert-danger alert-dismissible fade show" role="alert" th:if="${error != null}">
                                            <strong th:text="${error}"></strong>
                                            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                                        </div>
                                        <div th:if="${message != null}" class="alert alert-danger alert-dismissible fade show" role="alert">
                                            <div class="table-responsive">
                                                <table>
                                                    <tr>
                                                        <th>Account</th>
                                                        <th>DEBET</th>
                                                        <th>CREDIT</th>
                                                    </tr>
                                                    <tr th:each="data, row:${message}">
                                                        <td th:text="${data.account.name}"></td>
                                                        <td>
                                                            <span th:text="${#numbers.formatDecimal(data.amount,  0, 'POINT', 2, 'COMMA')}" th:if="${data.balanceType.toString() == 'DEBET'}"></span>
                                                        </td>
                                                        <td>
                                                            <span th:text="${#numbers.formatDecimal(data.amount,  0, 'POINT', 2, 'COMMA')}" th:if="${data.balanceType.toString() == 'CREDIT'}"></span>
                                                        </td>
                                                    </tr>
                                                    <tr>
                                                        <th>Total</th>
                                                        <th th:text="${#numbers.formatDecimal(totalDebet,  0, 'POINT', 2, 'COMMA')}"></th>
                                                        <th th:text="${#numbers.formatDecimal(totalCredit,  0, 'POINT', 2, 'COMMA')}"></th>
                                                    </tr>
                                                    <tr>
                                                        <th>Status</th>
                                                        <th colspan="2">
                                                            <b class="badge text-bg-danger" th:text="${messageJournal}">Not Balance</b>
                                                        </th>
                                                    </tr>
                                                </table>
                                            </div>
                                            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                                        </div>
                                        <form th:action="@{/journal/create}" method="post">
                                            <div class="form-group mb-2">
                                                <label>Template</label>
                                                <input type="text" th:value="${template.code + ' - ' + template.name}" disabled class="form-control">
                                                <input type="hidden" name="journalTemplate" th:value="${template.id}">
                                                <input type="hidden" th:if="${templateDetailValidation != null}"
                                                       th:id="validation" th:value="${templateDetailValidation.detail}">
                                                <input type="hidden" th:if="${templateDetailValidation == null}"
                                                       th:id="validation" value="0">
                                                <input type="hidden" th:if="${templateDetailValidation != null}"
                                                       th:id="validationDebet" th:value="${templateDetailValidation.debet}">
                                                <input type="hidden" th:if="${templateDetailValidation != null}"
                                                       th:id="validationCredit" th:value="${templateDetailValidation.credit}">
                                            </div>
                                            <div class="form-group mb-2">
                                                <label>Date</label>
                                                <input type="date" required class="form-control" name="dateTransaction">
                                            </div>
                                            <div class="form-group mb-2">
                                                <label>Description</label>
                                                <textarea type="text" required class="form-control" name="description" th:value="${description}"></textarea>
                                            </div>
                                            <div class="form-group mb-3">
                                                <label>Institut</label>
                                                <select name="institut" class="form-select" required>
                                                    <option value="">-- Pilih --</option>
                                                    <option th:each="data, row:${institut}"
                                                            th:value="${data.id}"
                                                            th:text="${data.namaInstitut}"></option>
                                                </select>
                                            </div>
                                            <div class="form-group mb-2">
                                                <table class="table table-bordered table-striped">
                                                    <tr>
                                                        <th>Sequence</th>
                                                        <th>Account</th>
                                                        <th>Amount</th>
                                                        <th>Balance Type</th>
                                                    </tr>
                                                    <tr th:each="data, row:${templateDetail}">
                                                        <td th:text="${data.sequence}">1</td>
                                                        <td th:text="${data.account.name}"></td>
                                                        <td>
                                                            <input type="text" th:id="'numberInput' + ${row.index}"  class="form-control amount" name="amount">                                                        </td>
                                                        <td>
                                                            <span th:if="${data.balanceType.toString() == 'DEBET'}" class="badge text-bg-success">DEBET</span>
                                                            <span th:if="${data.balanceType.toString() == 'CREDIT'}" class="badge text-bg-warning">CREDIT</span>
                                                        </td>
                                                    </tr>
                                                    <tr th:if="${templateDetailValidation == null}">
                                                        <td colspan="4" >
                                                            <div class="alert alert-danger">
                                                                <b>
                                                                    Detail Template Jurnal tidak ditemukan. Mohon diisi terlebih dahulu.
                                                                </b>
                                                            </div>
                                                        </td>
                                                    </tr>
                                                    <tr th:if="${templateDetailValidation != null}">
                                                        <td colspan="4">
                                                            <div class="alert alert-danger" th:if="${templateDetailValidation.detail < 2}">
                                                                <b>
                                                                    Dalam suatu template jurnal, disarankan untuk memiliki minimal dua atau lebih
                                                                    rincian template jurnal, dengan keharusan mencakup transaksi debet dan kredit.
                                                                </b>
                                                            </div>
                                                        </td>
                                                    </tr>
                                                    <tr th:if="${templateDetailValidation.debet < 1}">
                                                        <td colspan="4">
                                                            <div class="alert alert-danger">
                                                                Belum ada catatan debet.
                                                            </div>
                                                        </td>
                                                    </tr>
                                                    <tr th:if="${templateDetailValidation.credit < 1}">
                                                        <td colspan="4">
                                                            <div class="alert alert-danger">
                                                                Belum ada catatan credit.
                                                            </div>
                                                        </td>
                                                    </tr>
                                                </table>
                                            </div>

                                            <div class="form-group mb-2">
                                                <button class="btn btn-primary" id="btn-submit" type="submit">Generate Journal</button>
                                            </div>

                                        </form>
                                    </div>
                                </div>
                            </div>

                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
</main>
<div layout:fragment="footer" class="script">
    <!-- JavaScript untuk Select2 dan Memuat Data dari API -->
    <script>
        var validation = $('#validation').val();
        var validationDebet = $('#validationDebet').val();
        var validationCredit = $('#validationCredit').val();
        if (validation == 0 || validation < 2){
            document.getElementById("btn-submit").disabled = true;
        }else {
            document.getElementById("btn-submit").disabled = false;
        }

        if (validationDebet == 0){
            document.getElementById("btn-submit").disabled = true;
        }else {
            document.getElementById("btn-submit").disabled = false;
        }

        if (validationCredit == 0){
            document.getElementById("btn-submit").disabled = true;
        }else {
            document.getElementById("btn-submit").disabled = false;
        }

        document.addEventListener('DOMContentLoaded', function () {
            var inputs = document.querySelectorAll('[id^="numberInput"]');
            inputs.forEach(function(input) {
                input.addEventListener('input', function(e) {
                    let value = e.target.value;

                    // Menghapus karakter yang bukan angka atau koma
                    value = value.replace(/[^\d,]/g, '');

                    // Jika ada lebih dari satu koma, ambil hanya bagian sebelum koma pertama
                    const parts = value.split(',');
                    value = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, '.');
                    if (parts.length > 1) {
                        value += ',' + parts[1];
                    }

                    // Mengupdate nilai input
                    e.target.value = value;
                });
            });
        });

    </script>
    <script>
        $(document).ready(function () {
            // Inisialisasi Select2 pada elemen Select pertama
            $('#select-category').select2({
                theme: 'bootstrap-5',
                ajax: {
                    url: '/api/category',
                    dataType: 'json',
                    processResults: function (response) {
                        return {
                            results: response.data.map(function (item) {
                                return {
                                    id: item.id,
                                    text: item.category
                                };
                            })
                        };
                    }
                },
                placeholder: 'Pilih Kategori',
                minimumInputLength: 0
            });

            // Inisialisasi Select2 pada elemen Select kedua
            $('#select-subcategory').select2({
                theme: 'bootstrap-5',
                placeholder: 'Pilih Subkategori'
            });

            // Menangani perubahan nilai pada Select pertama
            $('#select-category').on('change', function () {
                var selectedCategoryId = $(this).val();

                // Lakukan AJAX untuk memuat data berdasarkan nilai yang dipilih
                $.ajax({
                    url: '/api/category/journal-template?category=' + selectedCategoryId,
                    dataType: 'json',
                    success: function (response) {
                        // Hapus opsi lama dari Select kedua
                        $('#select-subcategory').empty();

                        // Tambahkan opsi baru ke Select kedua
                        $('#select-subcategory').select2({
                            data: response.data.map(function (item) {
                                return {
                                    id: item.id,
                                    text: item.code + ' - ' + item.name
                                };
                            })
                        });
                    }
                });
            });
        });
    </script>

</div>
</body>
</html>